<?php
/*

	* cache294.class
	
		v.	E3-1	リリース

*/

class cache294 {

	public $directory;
	public $limit;

	function __construct( $dir="", $lim=86400 ) {
	
		if( empty($dir) )
			$dir = getcwd();
	
		if( !is_writable( $dir ) ) {
			echo "[cache294] Error. Do no write a directory.<br />\n";
			return FALSE;
		}
		if( !is_int( $lim ) ) {
			echo "[cache294] Error. Limit is integer.<br />\n";
			return FALSE;
		}
		$this->directory = $dir;
		$this->limit = $lim;
		
		return TRUE;
	
	}
	
	// put
	public function put( $name, $value ) {
		
		if( empty($name) || empty($value) ) {
			echo "[cache294] cache294::put( cacheName, cacheData ).<br />\n";
			return FALSE;
		}
		
		if( is_array($value) )
			$value = json_encode( $value );
		
		if( !file_put_contents( $this->directory."/".md5($name), $value ) ) {
			echo "[cache294] cache294::put Do not cached.<br />\n";
			return FALSE;
		}
		
		return TRUE;
		
	}
	
	// get
	public function get( $name, $lim="" ) {
	
		if( empty( $lim ) )
			$lim = $this->limit;
			
		if( empty($name) || !is_int($lim) ) {
			echo "[cache294] cache294::get( cacheName (,limitTime) ).<br />\n";
			return FALSE;
		}
		
		$value = @file_get_contents($this->directory."/".md5($name));
		if( !$value ) {
//			echo "[cache294] cache294::get cache:".$name." is not found.<br />\n";
			return FALSE;
		}
		
		if( time() > filemtime($this->directory."/".md5($name))+$this->limit )
			return FALSE;
		
		$flg = json_decode($value);
		if( $flg )
			$value = $flg;
		
		return $value;
	
	}
	
	// del
	public function del( $name ) {
	
		if( empty($name) ) {
			echo "[cache294] cache294::del( cacheName ).<br />\n";
			return FALSE;
		}
		
		if( !@unlink($this->directory."/".md5($name)) ) {
			echo "[cache294] cache294::del cache:".$name." is not deleted.<br />\n";
			return FALSE;
		}
		
		return TRUE;
	
	}
	


}

?>
